"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var model_1 = require("./model");
var AudioService = (function () {
    function AudioService() {
        this.audioInit();
        this.serviceInit();
    }
    AudioService.prototype.Toggle = function (audio) {
        var tryGet = audio ?
            this.playList.findIndex(function (p) { return p.Src === audio.Src; }) :
            this.playData.Index;
        if (tryGet < 0) {
            this.playList.push(audio);
            this.PlayIndex(this.playList.length);
        }
        else {
            if (tryGet === this.playData.Index) {
                if (this._audio.paused) {
                    this._audio.play();
                    this.playData.Playing = true;
                }
                else {
                    this._audio.pause();
                    this.playData.Playing = false;
                }
            }
            else {
                this.PlayIndex(tryGet);
            }
        }
    };
    AudioService.prototype.Add = function (audio) {
        this.playList.push(audio);
        if (this.playList.length === 1) {
            this.PlayIndex(0);
        }
    };
    AudioService.prototype.Remove = function (index) {
        this.playList.splice(index, 1);
        if (!this.playList.length) {
            this._audio.src = '';
        }
        else {
            if (index === this.playData.Index) {
                this.PlayIndex(index);
            }
        }
    };
    AudioService.prototype.Next = function () {
        switch (this.playData.Order) {
            case model_1.PlayOrder.LINE:
                if (this.playData.Index < this.playList.length - 1) {
                    this.playData.Index++;
                    this.PlayIndex(this.playData.Index);
                }
                break;
            case model_1.PlayOrder.AROUND:
                this.playData.Index = (this.playData.Index + 1) % this.playList.length;
                this.PlayIndex(this.playData.Index);
                break;
            case model_1.PlayOrder.RANDOM:
                this.playData.Index = (this.playData.Index + 1) % this.playList.length;
                this.PlayIndex(this.playData.Index);
                console.log('暂不考虑随机播放将视为列表循环播放');
                break;
            case model_1.PlayOrder.SINGLE:
                this._audio.currentTime = 0;
                break;
            default:
                if (this.playData.Index < this.playList.length) {
                    this.playData.Index++;
                    this.PlayIndex(this.playData.Index);
                }
                break;
        }
    };
    AudioService.prototype.Prev = function () {
        switch (this.playData.Order) {
            case model_1.PlayOrder.LINE:
                if (this.playData.Index > 0) {
                    this.playData.Index--;
                    this.PlayIndex(this.playData.Index);
                }
                break;
            case model_1.PlayOrder.AROUND:
                this.playData.Index = (this.playData.Index - 1) < 0 ?
                    (this.playList.length - 1) :
                    (this.playData.Index - 1);
                this.PlayIndex(this.playData.Index);
                break;
            case model_1.PlayOrder.RANDOM:
                this.playData.Index = (this.playData.Index - 1) < 0 ?
                    (this.playList.length - 1) :
                    (this.playData.Index - 1);
                this.PlayIndex(this.playData.Index);
                console.log('暂不考虑随机播放将视为列表循环播放');
                break;
            case model_1.PlayOrder.SINGLE:
                this._audio.currentTime = 0;
                break;
            default:
                if (this.playData.Index > 0) {
                    this.playData.Index--;
                    this.PlayIndex(this.playData.Index);
                }
                break;
        }
    };
    AudioService.prototype.Skip = function (percent) {
        this._audio.currentTime = this._audio.duration * percent;
        this.playData.Progress = this._audio.currentTime;
    };
    AudioService.prototype.PlayIndex = function (index) {
        index = this.playList[index] ? index :
            this.playList[index + 1] ? (index + 1) :
                this.playList[index - 1] ? (index - 1) : -1;
        if (index !== -1) {
            this._audio.src = this.playList[index].Src;
            if (this._audio.paused) {
                this._audio.play();
                this.playData.Playing = true;
            }
            this.playData.Index = index;
        }
        else {
            console.log('nothing to be play');
        }
    };
    AudioService.prototype.PlayList = function () {
        return this.playList;
    };
    AudioService.prototype.PlayData = function () {
        return this.playData;
    };
    AudioService.prototype.CurrentAudio = function () {
        return this.playList[this.playData.Index] || {};
    };
    AudioService.prototype.serviceInit = function () {
        this.playList = [];
        this.playData = {
            Playing: false,
            Index: -1,
            Progress: -1,
            Order: model_1.PlayOrder.LINE,
            Data: 0
        };
    };
    AudioService.prototype.audioInit = function () {
        var _this = this;
        this._audio = new Audio();
        this._audio.autoplay = false;
        this._audio.onloadedmetadata = function () {
            _this.playList[_this.playData.Index].Duration = _this._audio.duration;
        };
        this._audio.onplay = function () {
            _this.dataInterval = window.setInterval(function () {
                _this.playData.Progress = _this._audio.currentTime;
                _this.playData.Data = _this._audio.buffered && _this._audio.buffered.length ?
                    (_this._audio.buffered.end(0) || 0) : 0;
            }, 1000);
            _this.playData.Playing = true;
        };
        this._audio.onpause = function () {
            window.clearInterval(_this.dataInterval);
            _this.playData.Playing = false;
            _this.playData.Progress = _this._audio.currentTime;
        };
        this._audio.onended = function () {
            window.clearInterval(_this.dataInterval);
            _this.playData.Playing = false;
            _this.playData.Progress = _this.playData.Data =
                _this.playList[_this.playData.Index].Duration;
        };
        this._audio.onabort = function () {
            window.clearInterval(_this.dataInterval);
            _this.playData.Playing = false;
            _this.playData.Progress = _this.playData.Data = 0;
        };
    };
    AudioService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [])
    ], AudioService);
    return AudioService;
}());
exports.AudioService = AudioService;
//# sourceMappingURL=service.js.map